## mingw-w64-sqlite-orm-1.9.1-1.src.tar.zst

=== CMakeLists.txt ===
# note: the minimum required version needs to go hand in hand with appveyor builds,
# which is CMake 3.16 for the Visual Studio 2017 build worker image
cmake_minimum_required (VERSION 3.16)

# PACKAGE_VERSION is used by cpack scripts currently
# Both sqlite_orm_VERSION and PACKAGE_VERSION should be the same for now

set(sqlite_orm_VERSION "1.9.1")
set(PACKAGE_VERSION ${sqlite_orm_VERSION})

project("sqlite_orm" VERSION ${PACKAGE_VERSION})

# Handling C++ standard version to use
option(SQLITE_ORM_ENABLE_CXX_20 "Enable C++ 20" OFF)
option(SQLITE_ORM_ENABLE_CXX_17 "Enable C++ 17" OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(SQLITE_ORM_ENABLE_CXX_20)
    set(CMAKE_CXX_STANDARD 20)
    message(STATUS "SQLITE_ORM: Build with C++20 features")
elseif(SQLITE_ORM_ENABLE_CXX_17)
    set(CMAKE_CXX_STANDARD 17)
    message(STATUS "SQLITE_ORM: Build with C++17 features")
else()
    # fallback to C++14 if there is no special instruction
    set(CMAKE_CXX_STANDARD 14)
    message(STATUS "SQLITE_ORM: Build with C++14 features")
endif()
set(CMAKE_CXX_EXTENSIONS OFF)


set(CMAKE_VERBOSE_MAKEFILE ON)

message(STATUS "Configuring ${PROJECT_NAME} ${sqlite_orm_VERSION}")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

include(CTest)

### Dependencies
add_subdirectory(dependencies)

### Main Build Targets
set(SqliteOrm_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/include")
add_library(sqlite_orm INTERFACE)
add_library(sqlite_orm::sqlite_orm ALIAS sqlite_orm)

find_package(SQLite3 REQUIRED)
target_link_libraries(sqlite_orm INTERFACE SQLite::SQLite3)

target_sources(sqlite_orm INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/sqlite_orm/sqlite_orm.h>)

target_include_directories(sqlite_orm INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)

include(ucm)

if (MSVC)
    string(REGEX REPLACE "/RTC(su|[1su])" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")    
    string(REGEX REPLACE "/RTC(su|[1su])" "" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")    
    string(REGEX REPLACE "/RTC(su|[1su])" "" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")    
    add_compile_options(/EHsc)
    if (MSVC_VERSION GREATER_EQUAL 1914)
        add_compile_options(/Zc:__cplusplus)
    endif()
    if (MSVC_VERSION GREATER_EQUAL 1910)
        # VC 2017 issues a deprecation warning for `strncpy`
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
    endif()
    add_compile_options(/MP) # multi-processor compilation
    if (CMAKE_CXX_STANDARD GREATER 14)
        add_compile_definitions(_SILENCE_CXX17_CODECVT_HEADER_DEPRECATION_WARNING)
    endif()

    if ("${CMAKE_GENERATOR}" MATCHES "(Win64|x64)")
        message(STATUS "Add /bigobj flag to compiler")
        add_compile_options(/bigobj)
    endif()
endif()

ucm_print_flags()
message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")

# Tests
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_TESTING)
    add_subdirectory(tests)
endif()

option(BUILD_EXAMPLES "Build code examples" OFF)
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

### Packaging
add_subdirectory(packaging)

=== dependencies/CMakeLists.txt ===
include(FetchContent)

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_TESTING)
    # FIND_PACKAGE_ARGS is available since 3.24
    if(CMAKE_VERSION VERSION_LESS 3.24)
        FetchContent_Declare(
            Catch2
            GIT_REPOSITORY https://github.com/catchorg/Catch2.git
            GIT_TAG v3.2.1
        )
    else()
        FetchContent_Declare(
            Catch2
            GIT_REPOSITORY https://github.com/catchorg/Catch2.git
            GIT_TAG v3.2.1
            # prefer find_package() over building from source
            FIND_PACKAGE_ARGS 3 CONFIG
        )
    endif()
endif()

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_TESTING)
    # CMake <3.24: exposes targets only locally, but caches them. So call FetchContent_MakeAvailable again in the directory of usage
    FetchContent_MakeAvailable(Catch2)
endif()

# CMake <3.24: exposes targets only locally, but caches them. So call find_package again in the directory of usage
find_package(SQLite3 REQUIRED)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# note: find_package(SQLite3 REQUIRED) already done in top-level CMakeLists

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

file(GLOB files "*.cpp")

set(run_example_targets)

foreach(file ${files})
    get_filename_component(file_basename ${file} NAME_WE)

    add_executable(${file_basename} ${file})
    # note: sqlite3 already linked in top-level CMakeLists

    target_link_libraries(${file_basename} PRIVATE sqlite_orm)

    add_custom_target(run_${file_basename}
        COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${file_basename}
        DEPENDS ${file_basename}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Running example: ${file_basename}"
        VERBATIM
    )

    list(APPEND run_example_targets run_${file_basename})
endforeach()

add_custom_target(run_all_examples
    DEPENDS ${run_example_targets}
)

=== packaging/CMakeLists.txt ===
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(SQLITE_ORM_INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/SqliteOrm CACHE STRING "Path to SqliteOrm cmake files")

configure_file(${PROJECT_SOURCE_DIR}/cmake/SqliteOrmConfig.cmake.in SqliteOrmConfig.cmake @ONLY)

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/SqliteOrmConfigVersion.cmake
				VERSION ${sqlite_orm_VERSION}
				COMPATIBILITY SameMajorVersion
				)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SqliteOrmConfig.cmake
				${CMAKE_CURRENT_BINARY_DIR}/SqliteOrmConfigVersion.cmake
				DESTINATION ${SQLITE_ORM_INSTALL_CMAKEDIR})

install(TARGETS sqlite_orm 
	EXPORT SqliteOrmTargets
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} 
        COMPONENT sqlite_orm_runtime
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}             
        COMPONENT          sqlite_orm_runtime           
    	NAMELINK_COMPONENT sqlite_orm_development   
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}           
        COMPONENT   sqlite_orm_development 
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/include/sqlite_orm DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT SqliteOrmTargets
	DESTINATION ${SQLITE_ORM_INSTALL_CMAKEDIR}
	NAMESPACE sqlite_orm::
	COMPONENT   sqlite_orm_development
)

=== tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.16)

# Note: find_package(SQLite3 REQUIRED) already done in top-level CMakeLists
FetchContent_MakeAvailable(Catch2)

option(SQLITE_ORM_OMITS_CODECVT "Omits codec testing" OFF)

# Glob all .cpp files recursively in the current directory
file(GLOB_RECURSE UNIT_TEST_SOURCES "*.cpp")

add_executable(unit_tests ${UNIT_TEST_SOURCES})

if(SQLITE_ORM_OMITS_CODECVT)
    message(STATUS "SQLITE_ORM_OMITS_CODECVT is enabled")
    target_compile_definitions(unit_tests PRIVATE SQLITE_ORM_OMITS_CODECVT=1)
endif()

if (MSVC)
    target_compile_options(unit_tests PUBLIC
        # multi-processor compilation
        /MP)
    if (MSVC_VERSION LESS_EQUAL 1900)
        target_compile_options(unit_tests PUBLIC
            # C4503: decorated name length exceeded
            /wd4503
            # C4800: forcing value to bool (performance warning)
            /wd4800)
    else()
        target_compile_options(unit_tests PUBLIC
            # warning-level 4
            /W4
            # C4127: conditional expression is constant
            /wd4127
            # C4456: declaration of 'symbol' hides previous local declaration
            /wd4456
            # C4458: declaration of 'symbol' hides class member
            /wd4458)
    endif()
    if (CMAKE_CXX_FLAGS MATCHES "/D_UNICODE")
        # explicitly set the entry point of the executable file,
        # otherwise for some reason the linker will not pick up `wmain`, which is provided by the static Catch2 library
        target_link_options(unit_tests PRIVATE "/ENTRY:wmainCRTStartup")
    endif()
endif()

target_precompile_headers(unit_tests PRIVATE
    <sqlite3.h>
    <sqlite_orm/sqlite_orm.h>
    <catch2/catch_all.hpp>)

# note: sqlite3 already linked in top-level CMakeLists
target_link_libraries(unit_tests PRIVATE sqlite_orm Catch2::Catch2WithMain)

add_test(NAME "All_in_one_unit_test"
    COMMAND unit_tests
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== examples/fetch_content/CMakeLists.txt ===
### Preamble ###
cmake_minimum_required(VERSION 3.15)
project(Test VERSION 0.1 LANGUAGES CXX)

##### Project wide setup ####
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

### Dependencies ###
add_subdirectory(dependencies)

### Main Targets ###
add_subdirectory(src)

=== examples/find_package/CMakeLists.txt ===
### Preamble ###
cmake_minimum_required(VERSION 3.15)
project(Test VERSION 0.1 LANGUAGES CXX)

##### Project wide setup ####
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

### Dependencies ###
find_package(SqliteOrm REQUIRED)

### Main Targets ###
add_subdirectory(src)

=== examples/fetch_content/dependencies/CMakeLists.txt ===
include(FetchContent)

# You can configure this for your need, presumbably you want speificy a git tag here instead of a branch
FetchContent_Declare(sqliteOrm
  GIT_REPOSITORY https://github.com/fnc12/sqlite_orm
  GIT_TAG        origin/dev
)

add_subdirectory(sqlite_orm)

=== examples/fetch_content/src/CMakeLists.txt ===
add_executable(Test)
target_link_libraries(Test PRIVATE sqlite_orm::sqlite_orm)

target_sources(Test 
    PRIVATE 
        main.cpp 
)

=== examples/fetch_content/dependencies/sqlite_orm/CMakeLists.txt ===
# Set here options for sliteOrm 
# for example set(BUILD_TESTING ON) if you want to have tests included of sqliteOrm
FetchContent_MakeAvailable(sqliteOrm)

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_realname=sqlite-orm
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.9.1
pkgrel=1
pkgdesc="SQLite ORM light header only library for modern C++ (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/fnc12/sqlite_orm"
license=('spdx:AGPL-3.0-or-later')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
depends=("${MINGW_PACKAGE_PREFIX}-sqlite3")
source=("${url}/archive/v${pkgver}/${_realname/-/_}-${pkgver}.tar.gz")
sha256sums=('de2db80e4f716a27c4e1f4cb8a356394e428676c98c90b0577b0431107d3cccf')

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DBUILD_TESTING=OFF \
    -DBUILD_EXAMPLES=OFF \
    "${_extra_config[@]}" \
    ../${_realname/-/_}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  install -Dm644 "${srcdir}/${_realname/-/_}-${pkgver}/README.md" \
    "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}/README.md"
  install -Dm644 "${srcdir}/${_realname/-/_}-${pkgver}/LICENSE" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}

# vim:set ts=2 sw=2 et:
